#  Licensed to the Apache Software Foundation (ASF) under one
#  or more contributor license agreements. See the NOTICE file
#  distributed with this work for additional information
#  regarding copyright ownership. The ASF licenses this file
#  to you under the Apache License, Version 2.0 (the
#  "License"); you may not use this file except in compliance
#  with the License. You may obtain a copy of the License at
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing,
#   software distributed under the License is distributed on an
#   "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
#   KIND, either express or implied. See the License for the
#   specific language governing permissions and limitations
#   under the License.

# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

import custos.server.core.IdentityService_pb2 as IdentityService__pb2
import custos.server.core.ResourceSecretService_pb2 as ResourceSecretService__pb2
from google.protobuf import struct_pb2 as google_dot_protobuf_dot_struct__pb2


class ResourceSecretManagementServiceStub(object):
    """Missing associated documentation comment in .proto file."""

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.getSecret = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getSecret',
                request_serializer=ResourceSecretService__pb2.GetSecretRequest.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.SecretMetadata.FromString,
                )
        self.getKVCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getKVCredential',
                request_serializer=ResourceSecretService__pb2.KVCredential.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.KVCredential.FromString,
                )
        self.addKVCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/addKVCredential',
                request_serializer=ResourceSecretService__pb2.KVCredential.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
                )
        self.updateKVCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/updateKVCredential',
                request_serializer=ResourceSecretService__pb2.KVCredential.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
                )
        self.deleteKVCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/deleteKVCredential',
                request_serializer=ResourceSecretService__pb2.KVCredential.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
                )
        self.getJWKS = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getJWKS',
                request_serializer=IdentityService__pb2.GetJWKSRequest.SerializeToString,
                response_deserializer=google_dot_protobuf_dot_struct__pb2.Struct.FromString,
                )
        self.getResourceCredentialSummary = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getResourceCredentialSummary',
                request_serializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.SecretMetadata.FromString,
                )
        self.getAllResourceCredentialSummaries = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getAllResourceCredentialSummaries',
                request_serializer=ResourceSecretService__pb2.GetResourceCredentialSummariesRequest.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.ResourceCredentialSummaries.FromString,
                )
        self.addSSHCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/addSSHCredential',
                request_serializer=ResourceSecretService__pb2.SSHCredential.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.AddResourceCredentialResponse.FromString,
                )
        self.addPasswordCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/addPasswordCredential',
                request_serializer=ResourceSecretService__pb2.PasswordCredential.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.AddResourceCredentialResponse.FromString,
                )
        self.addCertificateCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/addCertificateCredential',
                request_serializer=ResourceSecretService__pb2.CertificateCredential.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.AddResourceCredentialResponse.FromString,
                )
        self.getSSHCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getSSHCredential',
                request_serializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.SSHCredential.FromString,
                )
        self.getPasswordCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getPasswordCredential',
                request_serializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.PasswordCredential.FromString,
                )
        self.getCertificateCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getCertificateCredential',
                request_serializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.CertificateCredential.FromString,
                )
        self.deleteSSHCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/deleteSSHCredential',
                request_serializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
                )
        self.deletePWDCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/deletePWDCredential',
                request_serializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
                )
        self.deleteCertificateCredential = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/deleteCertificateCredential',
                request_serializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
                )
        self.getCredentialMap = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getCredentialMap',
                request_serializer=ResourceSecretService__pb2.CredentialMap.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.CredentialMap.FromString,
                )
        self.addCredentialMap = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/addCredentialMap',
                request_serializer=ResourceSecretService__pb2.CredentialMap.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.AddResourceCredentialResponse.FromString,
                )
        self.updateCredentialMap = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/updateCredentialMap',
                request_serializer=ResourceSecretService__pb2.CredentialMap.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
                )
        self.deleteCredentialMap = channel.unary_unary(
                '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/deleteCredentialMap',
                request_serializer=ResourceSecretService__pb2.CredentialMap.SerializeToString,
                response_deserializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
                )


class ResourceSecretManagementServiceServicer(object):
    """Missing associated documentation comment in .proto file."""

    def getSecret(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def getKVCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def addKVCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def updateKVCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def deleteKVCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def getJWKS(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def getResourceCredentialSummary(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def getAllResourceCredentialSummaries(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def addSSHCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def addPasswordCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def addCertificateCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def getSSHCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def getPasswordCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def getCertificateCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def deleteSSHCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def deletePWDCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def deleteCertificateCredential(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def getCredentialMap(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def addCredentialMap(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def updateCredentialMap(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def deleteCredentialMap(self, request, context):
        """Missing associated documentation comment in .proto file."""
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_ResourceSecretManagementServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'getSecret': grpc.unary_unary_rpc_method_handler(
                    servicer.getSecret,
                    request_deserializer=ResourceSecretService__pb2.GetSecretRequest.FromString,
                    response_serializer=ResourceSecretService__pb2.SecretMetadata.SerializeToString,
            ),
            'getKVCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.getKVCredential,
                    request_deserializer=ResourceSecretService__pb2.KVCredential.FromString,
                    response_serializer=ResourceSecretService__pb2.KVCredential.SerializeToString,
            ),
            'addKVCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.addKVCredential,
                    request_deserializer=ResourceSecretService__pb2.KVCredential.FromString,
                    response_serializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.SerializeToString,
            ),
            'updateKVCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.updateKVCredential,
                    request_deserializer=ResourceSecretService__pb2.KVCredential.FromString,
                    response_serializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.SerializeToString,
            ),
            'deleteKVCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.deleteKVCredential,
                    request_deserializer=ResourceSecretService__pb2.KVCredential.FromString,
                    response_serializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.SerializeToString,
            ),
            'getJWKS': grpc.unary_unary_rpc_method_handler(
                    servicer.getJWKS,
                    request_deserializer=IdentityService__pb2.GetJWKSRequest.FromString,
                    response_serializer=google_dot_protobuf_dot_struct__pb2.Struct.SerializeToString,
            ),
            'getResourceCredentialSummary': grpc.unary_unary_rpc_method_handler(
                    servicer.getResourceCredentialSummary,
                    request_deserializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.FromString,
                    response_serializer=ResourceSecretService__pb2.SecretMetadata.SerializeToString,
            ),
            'getAllResourceCredentialSummaries': grpc.unary_unary_rpc_method_handler(
                    servicer.getAllResourceCredentialSummaries,
                    request_deserializer=ResourceSecretService__pb2.GetResourceCredentialSummariesRequest.FromString,
                    response_serializer=ResourceSecretService__pb2.ResourceCredentialSummaries.SerializeToString,
            ),
            'addSSHCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.addSSHCredential,
                    request_deserializer=ResourceSecretService__pb2.SSHCredential.FromString,
                    response_serializer=ResourceSecretService__pb2.AddResourceCredentialResponse.SerializeToString,
            ),
            'addPasswordCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.addPasswordCredential,
                    request_deserializer=ResourceSecretService__pb2.PasswordCredential.FromString,
                    response_serializer=ResourceSecretService__pb2.AddResourceCredentialResponse.SerializeToString,
            ),
            'addCertificateCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.addCertificateCredential,
                    request_deserializer=ResourceSecretService__pb2.CertificateCredential.FromString,
                    response_serializer=ResourceSecretService__pb2.AddResourceCredentialResponse.SerializeToString,
            ),
            'getSSHCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.getSSHCredential,
                    request_deserializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.FromString,
                    response_serializer=ResourceSecretService__pb2.SSHCredential.SerializeToString,
            ),
            'getPasswordCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.getPasswordCredential,
                    request_deserializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.FromString,
                    response_serializer=ResourceSecretService__pb2.PasswordCredential.SerializeToString,
            ),
            'getCertificateCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.getCertificateCredential,
                    request_deserializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.FromString,
                    response_serializer=ResourceSecretService__pb2.CertificateCredential.SerializeToString,
            ),
            'deleteSSHCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.deleteSSHCredential,
                    request_deserializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.FromString,
                    response_serializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.SerializeToString,
            ),
            'deletePWDCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.deletePWDCredential,
                    request_deserializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.FromString,
                    response_serializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.SerializeToString,
            ),
            'deleteCertificateCredential': grpc.unary_unary_rpc_method_handler(
                    servicer.deleteCertificateCredential,
                    request_deserializer=ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.FromString,
                    response_serializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.SerializeToString,
            ),
            'getCredentialMap': grpc.unary_unary_rpc_method_handler(
                    servicer.getCredentialMap,
                    request_deserializer=ResourceSecretService__pb2.CredentialMap.FromString,
                    response_serializer=ResourceSecretService__pb2.CredentialMap.SerializeToString,
            ),
            'addCredentialMap': grpc.unary_unary_rpc_method_handler(
                    servicer.addCredentialMap,
                    request_deserializer=ResourceSecretService__pb2.CredentialMap.FromString,
                    response_serializer=ResourceSecretService__pb2.AddResourceCredentialResponse.SerializeToString,
            ),
            'updateCredentialMap': grpc.unary_unary_rpc_method_handler(
                    servicer.updateCredentialMap,
                    request_deserializer=ResourceSecretService__pb2.CredentialMap.FromString,
                    response_serializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.SerializeToString,
            ),
            'deleteCredentialMap': grpc.unary_unary_rpc_method_handler(
                    servicer.deleteCredentialMap,
                    request_deserializer=ResourceSecretService__pb2.CredentialMap.FromString,
                    response_serializer=ResourceSecretService__pb2.ResourceCredentialOperationStatus.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'org.apache.custos.resource.secret.management.service.ResourceSecretManagementService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class ResourceSecretManagementService(object):
    """Missing associated documentation comment in .proto file."""

    @staticmethod
    def getSecret(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getSecret',
            ResourceSecretService__pb2.GetSecretRequest.SerializeToString,
            ResourceSecretService__pb2.SecretMetadata.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def getKVCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getKVCredential',
            ResourceSecretService__pb2.KVCredential.SerializeToString,
            ResourceSecretService__pb2.KVCredential.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def addKVCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/addKVCredential',
            ResourceSecretService__pb2.KVCredential.SerializeToString,
            ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def updateKVCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/updateKVCredential',
            ResourceSecretService__pb2.KVCredential.SerializeToString,
            ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def deleteKVCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/deleteKVCredential',
            ResourceSecretService__pb2.KVCredential.SerializeToString,
            ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def getJWKS(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getJWKS',
            IdentityService__pb2.GetJWKSRequest.SerializeToString,
            google_dot_protobuf_dot_struct__pb2.Struct.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def getResourceCredentialSummary(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getResourceCredentialSummary',
            ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
            ResourceSecretService__pb2.SecretMetadata.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def getAllResourceCredentialSummaries(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getAllResourceCredentialSummaries',
            ResourceSecretService__pb2.GetResourceCredentialSummariesRequest.SerializeToString,
            ResourceSecretService__pb2.ResourceCredentialSummaries.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def addSSHCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/addSSHCredential',
            ResourceSecretService__pb2.SSHCredential.SerializeToString,
            ResourceSecretService__pb2.AddResourceCredentialResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def addPasswordCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/addPasswordCredential',
            ResourceSecretService__pb2.PasswordCredential.SerializeToString,
            ResourceSecretService__pb2.AddResourceCredentialResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def addCertificateCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/addCertificateCredential',
            ResourceSecretService__pb2.CertificateCredential.SerializeToString,
            ResourceSecretService__pb2.AddResourceCredentialResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def getSSHCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getSSHCredential',
            ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
            ResourceSecretService__pb2.SSHCredential.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def getPasswordCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getPasswordCredential',
            ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
            ResourceSecretService__pb2.PasswordCredential.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def getCertificateCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getCertificateCredential',
            ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
            ResourceSecretService__pb2.CertificateCredential.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def deleteSSHCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/deleteSSHCredential',
            ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
            ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def deletePWDCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/deletePWDCredential',
            ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
            ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def deleteCertificateCredential(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/deleteCertificateCredential',
            ResourceSecretService__pb2.GetResourceCredentialByTokenRequest.SerializeToString,
            ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def getCredentialMap(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/getCredentialMap',
            ResourceSecretService__pb2.CredentialMap.SerializeToString,
            ResourceSecretService__pb2.CredentialMap.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def addCredentialMap(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/addCredentialMap',
            ResourceSecretService__pb2.CredentialMap.SerializeToString,
            ResourceSecretService__pb2.AddResourceCredentialResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def updateCredentialMap(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/updateCredentialMap',
            ResourceSecretService__pb2.CredentialMap.SerializeToString,
            ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def deleteCredentialMap(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/org.apache.custos.resource.secret.management.service.ResourceSecretManagementService/deleteCredentialMap',
            ResourceSecretService__pb2.CredentialMap.SerializeToString,
            ResourceSecretService__pb2.ResourceCredentialOperationStatus.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
